
#define array_search
// Array search script, by Alasdair Forsythe
// argument0 is the name of the array
// argument1 is the search for x
// argument2 is the search for y
// argument3 is what to change it to (not needed if you're browsing)

// NOTE: There's no point using this if you're just searching with numbers
// eg. if you want x2,y5 then it's just at array[2,5]

execute_string('maxxq=' + argument0 + 'x; maxyq=' + argument0 + 'y')

// sort out what was put in x
if is_real(argument1) pathx=argument1
else pathx=-3

for (runthruz=1; runthruz<=maxxq && pathx<0; runthruz+=1)
{
execute_string('tempb=' + argument0 + '[' + string(runthruz) + ',0]')
if pathx==-1 execute_string('if ' + tempb + ' pathx=runthruz')//true
if pathx==-2 execute_string('if ' + tempb + ' pathz=pathz else pathx=runthruz')//false
if pathx==-3 if tempb==argument1 pathx=runthruz //name
}

// sort out what was put in y
if is_real(argument2) pathy=argument2
else pathy=-3

for (runthruz=1; runthruz<=maxyq && pathy<0; runthruz+=1)
{
execute_string('tempb=' + argument0 + '[0,' + string(runthruz) + ']')
if pathy==-1 execute_string('if ' + tempb + ' pathy=runthruz')//true
if pathy==-2 execute_string('if ' + tempb + ' pathz=pathz else pathy=runthruz')//false
if pathy==-3 if tempb==argument2 pathy=runthruz //name
}

//If not found>
if pathx<0 || pathy<0 return -1

if is_real(argument3)
{
execute_string('templ=' + argument0 + '[' + string(pathx) + ',' + string(pathy) + ']')
if string(real(templ))==templ return real(templ) else return templ
}
else execute_string(argument0 + '[' + string(pathx) + ',' + string(pathy) + ']=argument3')

#define array_table
// Arrayise table script, by Alasdair Forsythe
// argument0 is the file/path of the database
// argument1 is the table position (no./string/command - if you're writing this will be overwriten)
// argument2 is the variable to put it into/pull it out of (must be a string)
// argument3 is if to write it to the table
// (0/false = put it into the array, 1/true = put the array back into the database file)

// The variable you put the table into with x and y on the end is the total x and y of the table
// eg.
// if argument2 is equal to 'bob'
// bobx would contain the total columns
// boby would contain the total rows

if !file_exists(argument0) return -1
file_open_read(argument0)
encrypttq=file_read_real(); file_readln()
tottablesq=file_read_string() // get total z
if encrypttq==true tottablesq=encryption(tottablesq,false)
tottablesq=real(tottablesq)
file_readln(); onlineq=3

if is_real(argument1) // work out if string/real was put
pathz=argument1 else pathz=-3 // work out what to search for (string/real/execute)

if pathz<=0 // get z
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
for (runthruz=1; runthruz<=tottablesq && pathz<=0; runthruz+=1)
{
tempb=string_copy(templ,string_pos('{' + string(runthruz) + '}',templ)+2+string_length(string(runthruz)),string_pos('{' + string(runthruz+1) + '}',templ)-string_pos('{' + string(runthruz) + '}',templ)-(2+string_length(string(runthruz)))) // get part of line
if pathz==-1 execute_string('if ' + tempb + ' pathz=runthruz')//true
if pathz==-2 execute_string('if ' + tempb + ' pathz=pathz else pathz=runthruz')//false
if pathz==-3 if tempb==argument1 pathz=runthruz //name
}
}
file_readln(); onlineq+=1
// If not found >
if pathz<=0 return -1

// Put table title into array[0,0] >
execute_string(argument2 + "[0,0]='" + string_copy(templ,string_pos('{' + string(pathz) + '}',templ)+2+string_length(string(pathz)),string_pos('{' + string(pathz+1) + '}',templ)-string_pos('{' + string(pathz) + '}',templ)-(2+string_length(string(pathz)))) + "'")

for (runthruz=1; runthruz<=pathz; runthruz+=1) // goto z
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
if runthruz==pathz
{
if argument3==0
{
execute_string(argument2 + 'x=' + string_copy(templ,1,string_pos(',',templ)-1)) // get total x
execute_string('maxxq=' + argument2 + 'x')
} else execute_string('maxxq=' + string_copy(templ,1,string_pos(',',templ)-1))
}
if argument3==0
{
execute_string(argument2 + 'y=' + string_delete(templ,1,string_pos(',',templ))) // get total y
execute_string('maxyq=' + argument2 + 'y')
} else execute_string('maxyq=' + string_delete(templ,1,string_pos(',',templ)))
file_readln(); onlineq+=1
if runthruz!=pathz repeat(maxyq+2) {file_readln(); onlineq+=1} // goto next table
}

if argument3==0 //read from table
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
for (runthruz=1; runthruz<=maxxq; runthruz+=1) // get x names
execute_string(argument2 + '[' + string(runthruz) + ",0]='" + string_copy(templ,string_pos('{' + string(runthruz) + '}',templ)+2+string_length(string(runthruz)),string_pos('{' + string(runthruz+1) + '}',templ)-string_pos('{' + string(runthruz) + '}',templ)-(2+string_length(string(runthruz)))) + "'")
file_readln()

templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
for (runthruz=1; runthruz<=maxyq; runthruz+=1) // get y names
execute_string(argument2 + '[0,' + string(runthruz) + "]='" + string_copy(templ,string_pos('{' + string(runthruz) + '}',templ)+2+string_length(string(runthruz)),string_pos('{' + string(runthruz+1) + '}',templ)-string_pos('{' + string(runthruz) + '}',templ)-(2+string_length(string(runthruz)))) + "'")
file_readln()

for (runthruz=1; runthruz<=maxyq; runthruz+=1) // get data
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
for (tempb=1; tempb<=maxxq; tempb+=1)
execute_string(argument2 + '[' + string(tempb) + ',' + string(runthruz) + "]='" + string_copy(templ,string_pos('{' + string(tempb) + '}',templ)+2+string_length(string(tempb)),string_pos('{' + string(tempb+1) + '}',templ)-string_pos('{' + string(tempb) + '}',templ)-(2+string_length(string(tempb)))) + "'") // get part of line
file_readln()
}
file_close()
}
else // write into table
{
file_close()
templ=''
file_open_read(argument0)
for (runthruz=0; file_eof()==false; runthruz+=1) // put the whole file into a single variable string
{
templ+='{ln' + string(runthruz+1) + '}' + file_read_string()
file_readln()
}
templ+='{ln' + string(runthruz+1) + '}'
file_close()
maxrun=runthruz
runthrut=3

file_open_write(argument0)

file_write_string(string(encrypttq)) // write encrytion
file_writeln()

if encrypttq==false // if not encrypted
file_write_string(string(tottablesq)) // write total tables
else file_write_string(encryption(string(tottablesq)))
file_writeln()

// write new table name >
execute_string('skipq=' + argument2 + '[0,0]')
tempb=string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut))))
if encrypttq==true tempb=encryption(tempb,false)
if encrypttq==false
file_write_string(string_insert(skipq,string_delete(tempb,string_pos('{' + string(pathz) + '}',tempb)+2+string_length(string(pathz)),string_pos('{' + string(pathz+1) + '}',tempb)-string_pos('{' + string(pathz) + '}',tempb)-(2+string_length(string(pathz)))),string_pos('{' + string(pathz) + '}',tempb)+2+string_length(string(pathz))))
else
file_write_string(encryption(string_insert(skipq,string_delete(tempb,string_pos('{' + string(pathz) + '}',tempb)+2+string_length(string(pathz)),string_pos('{' + string(pathz+1) + '}',tempb)-string_pos('{' + string(pathz) + '}',tempb)-(2+string_length(string(pathz)))),string_pos('{' + string(pathz) + '}',tempb)+(2+string_length(string(pathz)))),true))
file_writeln()
runthrut+=1
// < end write new table name

while (runthrut<onlineq-1) // write back into the file
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
file_writeln(); runthrut+=1
}

// write array table >
execute_string('pathx=' + argument2 + 'x')
execute_string('pathy=' + argument2 + 'y')
runthruz=string(pathx) + ',' + string(pathy)
if encrypttq==true runthruz=encryption(runthruz,true)
file_write_string(runthruz)
file_writeln()

tempb='{1}'
for (runthruz=1; runthruz<=pathx; runthruz+=1) // write x names
{
execute_string('tempb+=' + argument2 + '[' + string(runthruz) + ',0]')
tempb+='{' + string(runthruz+1) + '}'
}
if encrypttq==true tempb=encryption(tempb,true)
file_write_string(tempb)
file_writeln()

tempb='{1}'
for (runthruz=1; runthruz<=pathy; runthruz+=1) // write y names
{
execute_string('tempb+=' + argument2 + '[0,' + string(runthruz) + ']')
tempb+='{' + string(runthruz+1) + '}'
}
if encrypttq==true tempb=encryption(tempb,true)
file_write_string(tempb)
file_writeln()

for (runthruz=1; runthruz<=pathy; runthruz+=1) // write data
{
tempb='{1}'
for (runthruw=1; runthruw<=pathx; runthruw+=1)
{
execute_string('tempb+=' + argument2 + '[' + string(runthruw) + ',' + string(runthruz) + ']')
tempb+='{' + string(runthruw+1) + '}'
}
if encrypttq==true tempb=encryption(tempb,true)
file_write_string(tempb)
file_writeln()
}
runthrut+=3+maxyq
// < end write array table

while(runthrut<=maxrun) // write end of file
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
if runthrut<maxrun file_writeln()
runthrut+=1
}

file_close()
templ='' // clear string containing the whole file
}

#define convert_direct
// Database conversion between encryption/decryption, by Alasdair Forsythe
// NOTE: You DON'T need this script to read an encrypted file.
// argument0 is the name/path of the database to change
// argument1 is if to encrypt it (false/0=decrypt, true/1=encrypt)

{
templ=''
file_open_read(argument0)
for (runthruz=0; file_eof()==false; runthruz+=1) // put the whole file into a single variable string
{
templ+='{ln' + string(runthruz+1) + '}' + file_read_string()
file_readln()
}
templ+='{ln' + string(runthruz+1) + '}'
file_close()
maxrun=runthruz
runthrut=2

file_open_write(argument0)
if argument1==0 file_write_string('0') else file_write_string('1')
file_writeln()

while (runthrut<=maxrun) // write back into the file
{
tempb=(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
file_write_string(encryption(tempb,argument1))
if runthrut<maxrun file_writeln()
runthrut+=1
}

file_close()
templ=''
}

#define database_create
// Database creation script, by Alasdair Forsythe
// argument0 is the database file/path
// argument1 is the number of tables
// argument2 is the number of columns
// argument3 is the number of rows
// argument4 is if it should be encrypted or not

file_open_write(argument0)
file_write_string(string(argument4)); file_writeln()
tempb=string(argument1)
if argument4==1 tempb=encryption(tempb,1)
file_write_string(tempb)
file_writeln()

tempb='{1}'
for (runthruz=1; runthruz<=argument1; runthruz+=1)
tempb+=string(runthruz) + '{' + string(runthruz+1) + '}'
if argument4==1 tempb=encryption(tempb,1)
file_write_string(tempb); file_writeln()

repeat(argument1)
{
tempb=string(argument2) + ',' + string(argument3)
if argument4==1 tempb=encryption(tempb,1)
file_write_string(tempb)
file_writeln()

tempb='{1}'
for (runthruz=1; runthruz<=argument2; runthruz+=1)
tempb+=string(runthruz) + '{' + string(runthruz+1) + '}'
if argument4==1 tempb=encryption(tempb,1)
file_write_string(tempb); file_writeln()

tempb='{1}'
for (runthruz=1; runthruz<=argument3; runthruz+=1)
tempb+=string(runthruz) + '{' + string(runthruz+1) + '}'
if argument4==1 tempb=encryption(tempb,1)
file_write_string(tempb); file_writeln()

repeat (argument3)
{
tempb='{1}'
for (runthruz=1; runthruz<=argument2; runthruz+=1)
tempb+=string(runthruz) + '{' + string(runthruz+1) + '}'
if argument4==1 tempb=encryption(tempb,1)
file_write_string(tempb); file_writeln()
}
}

file_close()

#define encryption
// String encryption script, by Alasdair Forsythe
// NOTE: The string must not contain the characters ~ or ^
// argument0 is the string to encrypt/decrypt
// argument1 is if to encrypt it (false/0=decrypt, true/1=encrypt)

answerq=argument0
changeatq=2
for (runthruq=0; runthruq<string_length(answerq); runthruq+=changeatq)
{
tempe=string_copy(answerq,runthruq+1,1)
changeq=tempe
if argument1==0
{
if tempe=='a' changeq='~' else
if tempe=='g' changeq='a' else
if tempe=='1' changeq='g' else
if tempe=='y' changeq='1' else
if tempe=='W' changeq='y' else
if tempe=='6' changeq='W' else
if tempe=='(' changeq='6' else
if tempe=='}' changeq='(' else
if tempe=='b' changeq='}' else
if tempe=='P' changeq='b' else
if tempe=='e' changeq='P' else
if tempe=='2' changeq='e' else
if tempe=='{' changeq='2' else
if tempe=='>' changeq='{' else
if tempe=='<' changeq='>' else
if tempe=='5' changeq='<' else
if tempe=='A' changeq='5' else
if tempe==' ' changeq='A' else
if tempe=='3' changeq=' ' else
if tempe=='|' changeq='3' else
if tempe=='n' changeq='|' else
if tempe=='/' changeq='n' else
if tempe=='!' changeq='/' else
if tempe=='O' changeq='!' else
if tempe=='"' changeq='O' else
if tempe=='i' changeq='"' else
if tempe=='f' changeq='i' else
if tempe=='L' changeq='f' else
if tempe=='u' changeq='L' else
if tempe=="'" changeq='u' else
if tempe=='S' changeq="'" else
if tempe=='9' changeq='S' else
if tempe==',' changeq='9' else
if tempe=='7' changeq=',' else
if tempe=='X' changeq='7' else
if tempe=='x' changeq='X' else
if tempe=='0' changeq='x' else
if tempe==';' changeq='0' else
if tempe=='-' changeq=';' else
if tempe=='+' changeq='-' else
if tempe=='4' changeq='+' else
if tempe=='H' changeq='4' else
if tempe=='v' changeq='H' else
if tempe=='8' changeq='v' else
if tempe=='r' changeq='8' else
if tempe=='m' changeq='r' else
if tempe=='?' changeq='m' else
if tempe=='d' changeq='?' else
if tempe=='o' changeq='d' else
if tempe=='[' changeq='o' else
if tempe=='j' changeq='[' else
if tempe=='h' changeq='j' else
if tempe==']' changeq='h' else
if tempe=='t' changeq=']' else
if tempe=='E' changeq='t' else
if tempe=='.' changeq='E' else
if tempe=='z' changeq='.' else
if tempe=='*' changeq='z' else
if tempe=='c' changeq='*' else
if tempe=='=' changeq='c' else
if tempe=='G' changeq='=' else
if tempe=='&' changeq='G' else
if tempe=='R' changeq='&' else
if tempe=='_' changeq='R' else
if tempe=='M' changeq='_' else
if tempe=='^' changeq='M'
}
else
{
if tempe=='~' changeq='a' else
if tempe=='a' changeq='g' else
if tempe=='g' changeq='1' else
if tempe=='1' changeq='y' else
if tempe=='y' changeq='W' else
if tempe=='W' changeq='6' else
if tempe=='6' changeq='(' else
if tempe=='(' changeq='}' else
if tempe=='}' changeq='b' else
if tempe=='b' changeq='P' else
if tempe=='P' changeq='e' else
if tempe=='e' changeq='2' else
if tempe=='2' changeq='{' else
if tempe=='{' changeq='>' else
if tempe=='>' changeq='<' else
if tempe=='<' changeq='5' else
if tempe=='5' changeq='A' else
if tempe=='A' changeq=' ' else
if tempe==' ' changeq='3' else
if tempe=='3' changeq='|' else
if tempe=='|' changeq='n' else
if tempe=='n' changeq='/' else
if tempe=='/' changeq='!' else
if tempe=='!' changeq='O' else
if tempe=='O' changeq='"' else
if tempe=='"' changeq='i' else
if tempe=='i' changeq='f' else
if tempe=='f' changeq='L' else
if tempe=='L' changeq='u' else
if tempe=="u" changeq="'" else
if tempe=="'" changeq="S" else
if tempe=='S' changeq='9' else
if tempe=='9' changeq=',' else
if tempe==',' changeq='7' else
if tempe=='7' changeq='X' else
if tempe=='X' changeq='x' else
if tempe=='x' changeq='0' else
if tempe=='0' changeq=';' else
if tempe==';' changeq='-' else
if tempe=='-' changeq='+' else
if tempe=='+' changeq='4' else
if tempe=='4' changeq='H' else
if tempe=='H' changeq='v' else
if tempe=='v' changeq='8' else
if tempe=='8' changeq='r' else
if tempe=='r' changeq='m' else
if tempe=='m' changeq='?' else
if tempe=='?' changeq='d' else
if tempe=='d' changeq='o' else
if tempe=='o' changeq='[' else
if tempe=='[' changeq='j' else
if tempe=='j' changeq='h' else
if tempe=='h' changeq=']' else
if tempe==']' changeq='t' else
if tempe=='t' changeq='E' else
if tempe=='E' changeq='.' else
if tempe=='.' changeq='z' else
if tempe=='z' changeq='*' else
if tempe=='*' changeq='c' else
if tempe=='c' changeq='=' else
if tempe=='=' changeq='G' else
if tempe=='G' changeq='&' else
if tempe=='&' changeq='R' else
if tempe=='R' changeq='_' else
if tempe=='_' changeq='M' else
if tempe=='M' changeq='^'
}
answerq=string_insert(changeq,string_delete(answerq,runthruq+1,1),runthruq+1)
if changeatq==1 changeatq=2 else {if changeatq==2 changeatq=3 else changeatq=1}
}
return answerq

#define ins_table_direct
// Insert/delete table script, by Alasdair Forsythe
// argument0 is the file/path of the database
// argument1 is the position
// argument2 is if to create it (0/false=delete, 1/true=create)
// argument3 is the number of cols (not used if deleting)
// argument4 is the number of rows (not used if deleting)

{
if !file_exists(argument0) return -1
file_open_read(argument0)
encrypttq=file_read_real(); file_readln()
tottablesq=file_read_string() // get total z
if encrypttq==true tottablesq=encryption(tottablesq,false)
tottablesq=real(tottablesq)
file_readln(); file_readln(); onlineq=4

// reduce values that are too high >
if argument1>tottablesq+argument2 argument1=tottablesq+argument2

for (runthruz=1; runthruz<=argument1; runthruz+=1) // goto z
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
if runthruz==argument1
maxxq=real(string_copy(templ,1,string_pos(',',templ)-1)) // get total x
maxyq=real(string_delete(templ,1,string_pos(',',templ))) // get total y

if runthruz!=argument1
repeat(maxyq+3) {file_readln(); onlineq+=1} // goto next table
}
//onlineq+=1

// write into table >
file_close()
templ=''
file_open_read(argument0)
for (runthruz=1; file_eof()==false; runthruz+=1) // put the whole file into a single variable string
{
templ+='{ln' + string(runthruz) + '}' + file_read_string()
file_readln()
}
templ+='{ln' + string(runthruz) + '}'
file_close()
maxrun=runthruz-1

file_open_write(argument0)
runthrut=1 // write if encrypted >
file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
file_writeln(); runthrut+=1

// write new total tables >
if argument2==0 tempb=string(tottablesq-1)
else tempb=string(tottablesq+1)
if encrypttq==true tempb=encryption(tempb,true)
file_write_string(tempb); file_writeln(); runthrut+=1

// start write table names >
tempb=string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut))))
if encrypttq==true tempb=encryption(tempb,0)

if argument2==1 //if create
{
for (runthruz=tottablesq+1; runthruz>argument1; runthruz-=1) // move pointers that will be after new row along one
tempb=string_insert('{' + string(runthruz+1) + '}',string_delete(tempb,string_pos('{' + string(runthruz) + '}',tempb),2+string_length(string(runthruz))),string_pos('{' + string(runthruz) + '}',tempb))

tempb=string_insert(string(argument1) + '{' + string(argument1+1) + '}',tempb,string_pos('{' + string(argument1) + '}',tempb)+string_length(string(argument1))+2) // write in new column
}
else // if delete
{
tempb=string_delete(tempb,string_pos('{' + string(argument1) + '}',tempb),string_pos('{' + string(argument1+1) + '}',tempb)-string_pos('{' + string(argument1) + '}',tempb))

for (runthruz=tottablesq+1; runthruz>argument1; runthruz-=1) // move pointers that will be after new row along one
tempb=string_insert('{' + string(runthruz-1) + '}',string_delete(tempb,string_pos('{' + string(runthruz) + '}',tempb),2+string_length(string(runthruz))),string_pos('{' + string(runthruz) + '}',tempb))
}
if encrypttq==true tempb=encryption(tempb,1)
file_write_string(tempb)
file_writeln(); runthrut+=1
// < end write table names

if argument1>1 while (runthrut<onlineq) // write back into the file
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
file_writeln(); runthrut+=1
}

if argument2==0 runthrut+=maxyq+3 // if delete [miss out table data]
else // if create [create new blank table]
{
tempb=string(argument3) + ',' + string(argument4)
if encrypttq==true tempb=encryption(tempb,1)
file_write_string(tempb); file_writeln() // < write totx,toty

for ({tempb='{1}1{2}'; runthruz=2}; runthruz<=argument3; runthruz+=1) // write length of cols
tempb+=string(runthruz) + '{' + string(runthruz+1) + '}'
if encrypttq==true tempb=encryption(tempb,1)
file_write_string(tempb); file_writeln()

for ({tempb='{1}1{2}'; runthruz=2}; runthruz<=argument4; runthruz+=1) // write length of cols
tempb+=string(runthruz) + '{' + string(runthruz+1) + '}'
if encrypttq==true tempb=encryption(tempb,1)
file_write_string(tempb); file_writeln()

for ({tempb='{1}1{2}'; runthruz=2}; runthruz<=argument3; runthruz+=1) // write length of data (cols)
tempb+=string(runthruz) + '{' + string(runthruz+1) + '}'
if encrypttq==true tempb=encryption(tempb,1)
repeat(argument4) // write x/y names and data >
{file_write_string(tempb); file_writeln()}
}

while(runthrut<=maxrun) // write end of file
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
if runthrut<maxrun file_writeln()
runthrut+=1
}

file_close()
templ='' // clear string containing the whole file
}


#define inser_array
// Column/row array insert script, by Alasdair Forsythe
// argument0 is the table array name
// argument1 is the number along to insert it at
// argument2 is what to insert (false/0=column, true/1=row)
// argument3 is if to create it (false/0=delete, true/1=create)

execute_string('maxxq=' + argument0 + 'x; maxyq=' + argument0 + 'y')

// if the number along to insert is too high reduce it >
if argument2==0 if argument1>maxxq+argument3 argument1=maxxq+argument3
if argument2==1 if argument1>maxyq+argument3 argument1=maxyq+argument3

if argument2==1
{
if argument3==1
{
for (runthruz=maxyq; runthruz>=argument1; runthruz-=1) // through y
for (templ=0; templ<=maxxq; templ+=1) // through x
execute_string(argument0 + '[' + string(templ) + ',' + string(runthruz+1) + ']=' + argument0 + '[' + string(templ) + ',' + string(runthruz) + ']')
for (runthruz=0; runthruz<=maxxq; runthruz+=1) // clear indexes of new row
execute_string(argument0 + '[' + string(runthruz) + ',argument1]=string(' + string(argument1) + ')')
execute_string(argument0 + 'y+=1')
}
else
{
for (runthruz=argument1+1; runthruz<=maxyq; runthruz+=1) // through y
for (templ=0; templ<=maxxq; templ+=1) // through x
execute_string(argument0 + '[' + string(templ) + ',' + string(runthruz-1) + ']=' + argument0 + '[' + string(templ) + ',' + string(runthruz) + ']')
execute_string(argument0 + 'y-=1')
}
}

if argument2==0
{
if argument3==1
{
for (runthruz=maxxq; runthruz>=argument1; runthruz-=1) // through x
for (templ=0; templ<=maxyq; templ+=1) // through y
execute_string(argument0 + '[' + string(runthruz+1) + ',' + string(templ) + ']=' + argument0 + '[' + string(runthruz) + ',' + string(templ) + ']')
for (runthruz=0; runthruz<=maxyq; runthruz+=1) // clear indexs of new column
execute_string(argument0 + '[argument1,' + string(runthruz) + ']=string(' + string(argument1) + ')')
execute_string(argument0 + 'x+=1')
}
else
{
for (runthruz=argument1+1; runthruz<=maxxq; runthruz+=1) // through x
for (templ=0; templ<=maxyq; templ+=1) // through y
execute_string(argument0 + '[' + string(runthruz-1) + ',' + string(templ) + ']=' + argument0 + '[' + string(runthruz) + ',' + string(templ) + ']')
execute_string(argument0 + 'x-=1')
}
}

#define insert_direct
// Column/row insert script, by Alasdair Forsythe
// argument0 is the database name/path
// argument1 is the table to insert it at
// argument2 is the number along to insert it at
// argument3 is what to insert (false/0=column, true/1=row)
// argument4 is if to create it (false/0=delete, true/1=create)

{
if !file_exists(argument0) return -1
file_open_read(argument0)
encrypttq=file_read_real(); file_readln()
tottablesq=file_read_string() // get total z
if encrypttq==true tottablesq=encryption(tottablesq,false)
tottablesq=real(tottablesq)
file_readln(); onlineq=3

// sort out what was put in z
if is_real(argument1) pathz=argument1
else pathz=-3

templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
if pathz<=0 // get z
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
for (runthruz=1; runthruz<=tottablesq && pathz<=0; runthruz+=1)
{
tempb=string_copy(templ,string_pos('{' + string(runthruz) + '}',templ)+2+string_length(string(runthruz)),string_pos('{' + string(runthruz+1) + '}',templ)-string_pos('{' + string(runthruz) + '}',templ)-(2+string_length(string(runthruz)))) // get part of line
if pathz==-1 execute_string('if ' + tempb + ' pathz=runthruz')//true
if pathz==-2 execute_string('if ' + tempb + ' pathz=pathz else pathz=runthruz')//false
if pathz==-3 if tempb==argument1 pathz=runthruz //name
}
}
file_readln(); onlineq+=1
//if not found>
if pathz<=0 return -1

for (runthruz=1; runthruz<=pathz; runthruz+=1) // goto z
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
if runthruz==pathz
maxxq=real(string_copy(templ,1,string_pos(',',templ)-1)) // get total x
maxyq=real(string_delete(templ,1,string_pos(',',templ))) // get total y
file_readln(); onlineq+=1
if runthruz!=pathz repeat(maxyq+2) {file_readln(); onlineq+=1} // goto next table
}

// if the number along to insert is too high reduce it >
if argument3==0 if argument2>maxxq+argument4 argument2=maxxq+argument4
if argument3==1 if argument2>maxyq+argument4 argument2=maxyq+argument4

file_close()
templ=''
file_open_read(argument0)
for (runthruz=0; file_eof()==false; runthruz+=1) // put the whole file into a single variable string
{
templ+='{ln' + string(runthruz+1) + '}' + file_read_string()
file_readln()
}
templ+='{ln' + string(runthruz+1) + '}'
file_close()
maxrun=runthruz

if argument3==1 // write row >
{
file_open_write(argument0)
for (runthrut=1; runthrut<onlineq-1; runthrut+=1) // write back into the file
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
file_writeln()
}

if argument4==1 // if insert
{tempb=string(maxxq) + ',' + string(maxyq+1)}
else {tempb=string(maxxq) + ',' + string(maxyq-1)} // if delete
if encrypttq==true tempb=encryption(tempb)
file_write_string(tempb) // write new totx,toty
file_writeln()
runthrut+=1

file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
file_writeln(); runthrut+=1

// start write row name
tempb=string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut))))
if encrypttq==true tempb=encryption(tempb,0)

if argument4==1 //if insert
{
for (runthruz=maxyq+1; runthruz>argument2; runthruz-=1) // move pointers that will be after new row along one
tempb=string_insert('{' + string(runthruz+1) + '}',string_delete(tempb,string_pos('{' + string(runthruz) + '}',tempb),2+string_length(string(runthruz))),string_pos('{' + string(runthruz) + '}',tempb))

tempb=string_insert(string(argument2) + '{' + string(argument2+1) + '}',tempb,string_pos('{' + string(argument2) + '}',tempb)+string_length(string(argument2))+2) // write in new column
}
else // if delete
{
tempb=string_delete(tempb,string_pos('{' + string(argument2) + '}',tempb),string_pos('{' + string(argument2+1) + '}',tempb)-string_pos('{' + string(argument2) + '}',tempb))

for (runthruz=maxyq+1; runthruz>argument2; runthruz-=1) // move pointers that will be after new row along one
tempb=string_insert('{' + string(runthruz-1) + '}',string_delete(tempb,string_pos('{' + string(runthruz) + '}',tempb),2+string_length(string(runthruz))),string_pos('{' + string(runthruz) + '}',tempb))
}
if encrypttq==true tempb=encryption(tempb,1)
file_write_string(tempb)
file_writeln(); runthrut+=1
// end write row name

while (runthrut<onlineq+1+argument2) // write more of the file, up to row area
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
file_writeln()
runthrut+=1
}

if argument4==1
{
tempb='{1}'
for (runthruz=1; runthruz<=maxxq; runthruz+=1) // write row itself
tempb+=string(runthruz) + '{' + string(runthruz+1) + '}'
if encrypttq==true tempb=encryption(tempb,1)
file_write_string(tempb)
file_writeln()
} else runthrut+=1

} // < end write row
else // write column >
{
file_open_write(argument0)
for (runthrut=1; runthrut<onlineq-1; runthrut+=1) // write back into the file
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
file_writeln()
}

if argument4==1 // if create
tempb=string(maxxq+1) + ',' + string(maxyq)
else tempb=string(maxxq-1) + ',' + string(maxyq) // if delete
if encrypttq==true tempb=encryption(tempb)
file_write_string(tempb) // write new totx,toty
file_writeln(); runthrut+=1

// start write column name
tempb=string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut))))
if encrypttq==true tempb=encryption(tempb,0)

if argument4==true // if create
{
for (runthruz=maxxq+1; runthruz>argument2; runthruz-=1) // move pointers that will be after new col along one
tempb=string_insert('{' + string(runthruz+1) + '}',string_delete(tempb,string_pos('{' + string(runthruz) + '}',tempb),2+string_length(string(runthruz))),string_pos('{' + string(runthruz) + '}',tempb))

tempb=string_insert(string(argument2) + '{' + string(argument2+1) + '}',tempb,string_pos('{' + string(argument2) + '}',tempb)+string_length(string(argument2))+2) // write in new column
}
else // if delete
{
tempb=string_delete(tempb,string_pos('{' + string(argument2) + '}',tempb),string_pos('{' + string(argument2+1) + '}',tempb)-string_pos('{' + string(argument2) + '}',tempb))

for (runthruz=maxxq+1; runthruz>argument2; runthruz-=1) // move pointers that will be after new column along one
tempb=string_insert('{' + string(runthruz-1) + '}',string_delete(tempb,string_pos('{' + string(runthruz) + '}',tempb),2+string_length(string(runthruz))),string_pos('{' + string(runthruz) + '}',tempb))
}

if encrypttq==true tempb=encryption(tempb,1)
file_write_string(tempb)
file_writeln(); runthrut+=1
// end write column name

while (runthrut<onlineq+2) // write more of the file up to column area
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
file_writeln()
runthrut+=1
}

repeat (maxyq) // write column itself
{
tempb=string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut))))
if encrypttq==true tempb=encryption(tempb,0)

if argument4==1 // if create
{
for (runthruz=maxxq+1; runthruz>argument2; runthruz-=1) // move pointers that will be after new col along one
tempb=string_insert('{' + string(runthruz+1) + '}',string_delete(tempb,string_pos('{' + string(runthruz) + '}',tempb),2+string_length(string(runthruz))),string_pos('{' + string(runthruz) + '}',tempb))

tempb=string_insert(string(argument2) + '{' + string(argument2+1) + '}',tempb,string_pos('{' + string(argument2) + '}',tempb)+string_length(string(argument2))+2) // write in new column
}
else // if delete
{
tempb=string_delete(tempb,string_pos('{' + string(argument2) + '}',tempb),string_pos('{' + string(argument2+1) + '}',tempb)-string_pos('{' + string(argument2) + '}',tempb))

for (runthruz=maxxq+1; runthruz>argument2; runthruz-=1) // move pointers that will be after new column along one
tempb=string_insert('{' + string(runthruz-1) + '}',string_delete(tempb,string_pos('{' + string(runthruz) + '}',tempb),2+string_length(string(runthruz))),string_pos('{' + string(runthruz) + '}',tempb))
}

if encrypttq==true tempb=encryption(tempb,1)
file_write_string(tempb)
file_writeln(); runthrut+=1
}

} // < end write column

while(runthrut<=maxrun) // write end of file
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthrut) + '}',templ)+4+string_length(string(runthrut)),string_pos('{ln' + string(runthrut+1) + '}',templ)-string_pos('{ln' + string(runthrut) + '}',templ)-(4+string_length(string(runthrut)))))
file_writeln()
runthrut+=1
}

file_close()
templ='' // clear string containing the whole file
}

#define lookup_direct
// Database direct lookup script, by Alasdair Forsythe
// NOTE: The data must not contain {|numb|} or {ln|numb|} where |numb| is any positive number

// argument0 is the table name
// argument1 is z
// argument2 is x
// argument3 is y
// argument4 is what to change it to (must be a string)
// (don't bother to call argument4 if you just want the answer; putting 0/[leaving it blank] will mean it just returns it)

// Putting a real value in argument1,2,3 will make it go to that along - this is fastest
// Putting a string in argument1/2/3 will make it go to the one called this
// Putting -1 will make it check against all the names to see if they're true
// Putting -2 " " " if they're false (they must all be able to be tested for this)


{
if !file_exists(argument0) return -1
skipq=-1
lineonq=-1
file_open_read(argument0)
encrypttq=file_read_real(); file_readln()
tottablesq=file_read_string() // get total z
if encrypttq==true tottablesq=encryption(tottablesq,false)
tottablesq=real(tottablesq)
onlineq=3; file_readln()

if is_real(argument1) // work out if string/real was put
pathz=argument1 else pathz=-3

if is_real(argument2) && is_real(argument3)
if pathz>0 if argument2==0 && argument3==0 // if searching for table names
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
if is_string(argument4)
{skipq=argument1; lineonq=onlineq}
else
{
file_close()
return string_copy(templ,string_pos('{' + string(argument1) + '}',templ)+2+string_length(string(argument1)),string_pos('{' + string(argument1+1) + '}',templ)-string_pos('{' + string(argument1) + '}',templ)-(2+string_length(string(argument1))))
}
}

if pathz<=0 // get z
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
for (runthruz=1; runthruz<=tottablesq && pathz<=0; runthruz+=1)
{
tempb=string_copy(templ,string_pos('{' + string(runthruz) + '}',templ)+2+string_length(string(runthruz)),string_pos('{' + string(runthruz+1) + '}',templ)-string_pos('{' + string(runthruz) + '}',templ)-(2+string_length(string(runthruz)))) // get part of line
if pathz==-1 execute_string('if ' + tempb + ' pathz=runthruz')//true
if pathz==-2 execute_string('if ' + tempb + ' pathz=pathz else pathz=runthruz')//false
if pathz==-3 if tempb==argument1 pathz=runthruz //name

if pathz>0 if is_real(argument2) && is_real(argument3)
if argument2==0 && argument3==0 if is_string(argument4)
{skipq=runthruz; lineonq=onlineq} else {file_close(); return tempb}
}
}
file_readln(); onlineq+=1

for (runthruz=1; runthruz<=pathz; runthruz+=1) // goto z
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
if runthruz==pathz
maxxq=real(string_copy(templ,1,string_pos(',',templ)-1)) // get total x
maxyq=real(string_delete(templ,1,string_pos(',',templ))) // get total y
file_readln(); onlineq+=1
if runthruz!=pathz repeat(maxyq+2) {file_readln(); onlineq+=1} // goto next table
}

if is_real(argument2) pathx=argument2// work out if string/real was put
else pathx=-3

if pathx>0 if is_real(argument3) if argument3==0// if searching for row names
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
if is_string(argument4)
{skipq=argument2; lineonq=onlineq}
else
{
file_close()
return string_copy(templ,string_pos('{' + string(argument2) + '}',templ)+2+string_length(string(argument2)),string_pos('{' + string(argument2+1) + '}',templ)-string_pos('{' + string(argument2) + '}',templ)-(2+string_length(string(argument2))))
}
}

if pathx<0 // get x
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
for (runthruz=1; runthruz<=maxxq && pathx<=0; runthruz+=1)
{
tempb=string_copy(templ,string_pos('{' + string(runthruz) + '}',templ)+2+string_length(string(runthruz)),string_pos('{' + string(runthruz+1) + '}',templ)-string_pos('{' + string(runthruz) + '}',templ)-(2+string_length(string(runthruz)))) // get part of line
if pathx==-1 execute_string('if ' + tempb + ' pathx=runthruz')//true
if pathx==-2 execute_string('if ' + tempb + ' pathz=pathz else pathx=runthruz')//false
if pathx==-3 if tempb==argument2 pathx=runthruz //name
if pathx>0 if is_real(argument3) if argument3==0 if is_string(argument4) {skipq=runthruz; lineonq=onlineq} else {file_close(); return tempb}
}
}
onlineq+=1; file_readln()

if is_real(argument3) pathy=argument3 // work out if string/real was put
else pathy=-3

if pathy>0 if is_real(argument2) if argument2==0// if searching for column names
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
if is_string(argument4)
{skipq=argument3; lineonq=onlineq}
else
{
file_close()
return string_copy(templ,string_pos('{' + string(argument3) + '}',templ)+2+string_length(string(argument3)),string_pos('{' + string(argument3+1) + '}',templ)-string_pos('{' + string(argument3) + '}',templ)-(2+string_length(string(argument3))))
}
}

if pathy<0 // get y
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
for (runthruz=1; runthruz<=maxyq && pathy<=0; runthruz+=1)
{
tempb=string_copy(templ,string_pos('{' + string(runthruz) + '}',templ)+2+string_length(string(runthruz)),string_pos('{' + string(runthruz+1) + '}',templ)-string_pos('{' + string(runthruz) + '}',templ)-(2+string_length(string(runthruz)))) // get part of line
if pathy==-1 execute_string('if ' + tempb + ' pathy=runthruz')//true
if pathy==-2 execute_string('if ' + tempb + ' pathz=pathz else pathy=runthruz')//false
if pathy==-3 if tempb==argument3 pathy=runthruz //name

if pathy>0 if is_real(argument2) if argument2==0 if is_string(argument4) {skipq=runthruz; lineonq=onlineq} else {file_close(); return tempb}
}
}

// If answer is not found >
if pathz<=0 || pathx<0 || pathy<0 return -1

repeat (pathy) {file_readln(); onlineq+=1} // goto correct line for answer

if is_real(argument4) // if returning answer
{
templ=file_read_string()
if encrypttq==true templ=encryption(templ,false)
tempb=string_pos('{' + string(pathx) + '}',templ)
templ=string_copy(templ,tempb+2+string_length(string(pathx)),string_pos('{' + string(pathx+1) + '}',templ)-tempb-(2+string_length(string(pathx)))) // get answer

file_close()
if string(real(templ))==templ return real(templ) else return templ // return answer
}
else // if replacing
{
if skipq==-1 skipq=pathx
if lineonq==-1 lineonq=onlineq
file_close()
templ=''
file_open_read(argument0)
for (runthruz=0; file_eof()==false; runthruz+=1) // put the whole file into a single variable string
{
templ+='{ln' + string(runthruz+1) + '}' + file_read_string()
file_readln()
}
templ+='{ln' + string(runthruz+1) + '}'
file_close()
maxrun=runthruz

file_open_write(argument0)
for (runthruz=1; runthruz<lineonq; runthruz+=1) // write back into the file
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthruz) + '}',templ)+4+string_length(string(runthruz)),string_pos('{ln' + string(runthruz+1) + '}',templ)-string_pos('{ln' + string(runthruz) + '}',templ)-(4+string_length(string(runthruz)))))
file_writeln()
}
// write new part >
tempb=string_copy(templ,string_pos('{ln' + string(runthruz) + '}',templ)+4+string_length(string(runthruz)),string_pos('{ln' + string(runthruz+1) + '}',templ)-string_pos('{ln' + string(runthruz) + '}',templ)-(4+string_length(string(runthruz))))
if encrypttq==true tempb=encryption(tempb,false)
tempb=string_insert(argument4,string_delete(tempb,string_pos('{' + string(skipq) + '}',tempb)+2+string_length(string(skipq)),string_pos('{' + string(skipq+1) + '}',tempb)-string_pos('{' + string(skipq) + '}',tempb)-(2+string_length(string(skipq)))),string_pos('{' + string(skipq) + '}',tempb)+2+string_length(string(skipq)))
if encrypttq==true tempb=encryption(tempb,true)
file_write_string(tempb)
file_writeln()
runthruz+=1
// < end write new part

while(runthruz<=maxrun) // write end of file
{
file_write_string(string_copy(templ,string_pos('{ln' + string(runthruz) + '}',templ)+4+string_length(string(runthruz)),string_pos('{ln' + string(runthruz+1) + '}',templ)-string_pos('{ln' + string(runthruz) + '}',templ)-(4+string_length(string(runthruz)))))
if runthruz<maxrun file_writeln()
runthruz+=1
}

file_close()
templ='' // clear string containing the whole file
}
}
